#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define D 2      /*2x2x2̃[rbNL[uBSɂĂ4x4x4킯Ȃ*/

 
struct node{
  char surface[6][D][D];      /*[rbNL[ueʂ̏*/

  unsigned int cost;           /*̏Ԃɉŗem[hɋL*/
  unsigned int heuristic;      /*̃m[h̃q[XeBbNl*/
  unsigned int expectation;    /*heuristic+cost*/
  long double hash;           /*OɓWJm[hƓm[hWJȂ߂ɃnbVlg*/

  struct node *next[6];      /*WJqm[hւ̃|C^*/
  struct node *reverse;       /*em[hւ̃|C^BŌɉւ̃pXǂ߂Ɏg*/
  struct node *nextleaf;      /*݂̃[tXg\łȂB̃[tւ̃|C^*/
  struct node *revleaf;       /*Õ[tւ̃|C^*/
  struct node *nodelist;      /*nbVlׂ邽߂,m[hׂăjAɂȂB̃m[hւ̃|C^*/
  struct node *revnode;       /*Õm[hւ̃|C^*/

  char ope;                  /*em[h,ǂȏԕωė̂L*/
  char opecolor;             /*em[h炱̏ԂɗƂ,ǂ̖ʂ񂵂̂L*/

}root, goal, *minG, leaflist, endleaf, nodeend;

unsigned int min;      /*heuristic+cost̍ŏl*/


void start(void);          /*root̏Ȃ*/
void develop(struct node *cube);      /*m[hWJ*/
void allocate(struct node *cube);     /*m[hWJ邽߂,m*/
void heuristic(struct node *cube);    /*q[XeBbN֐*/
void operate(struct node *cube);      /*m[h̏ԑJڂs*/
void Rrot(struct node *next, struct node *original, char s);    /*ʂE90x]*/
void Lrot(struct node *next, struct node *original, char s);    /*ʂ90x]*/
void rot(struct node *next, struct node *original, char s);     /*ʂ180x]*/
void search(void);         /*heuristic+costŏ̃[tT*/
void output(void);         /*ւ̃pXǂĉ@\*/
void exception(void);      /*rootWJƂƓ*/


int main(void)
{
  unsigned int depth=0;


  start();    /*Ȃ̂*/

  develop(&root);  /*rootWJ*/

  exception();   /*rootWĴQ*/

  search();     /*WJׂ[tT*/

  while(minG->heuristic){    /*S[ԂłȂ胋[v*/

    if(minG->cost>depth)
      printf("%d\n",++depth);  /*ݓWJԐ[m[h̐[\*/

    develop(minG); /*[tWJ*/
    search();      /*ɓWJ郊[tT*/

  }

  output();    /*@\*/

  return 0;
}



void start(void)
{
  char i,j,k;

  for(i=0;i<6;i++)
    for(j=0;j<D;j++)
      for(k=0;k<D;k++)
        scanf(" %c ",&root.surface[i][j][k]);    /*Ԃ*/

  for(i=0;i<D;i++)
    for(j=0;j<D;j++)
      goal.surface[0][i][j]='y';    /*S[Ԃ`*/

  for(i=0;i<D;i++)
    for(j=0;j<D;j++)
      goal.surface[1][i][j]='r';

  for(i=0;i<D;i++)
    for(j=0;j<D;j++)
      goal.surface[2][i][j]='w';

  for(i=0;i<D;i++)
    for(j=0;j<D;j++)
      goal.surface[3][i][j]='b';

  for(i=0;i<D;i++)
    for(j=0;j<D;j++)
      goal.surface[4][i][j]='o';

  for(i=0;i<D;i++)
    for(j=0;j<D;j++)
      goal.surface[5][i][j]='g';

  root.cost=0;
  leaflist.nextleaf=&root;    /*Xg̏*/
  root.revleaf=&leaflist;
  root.heuristic=1;     
  root.opecolor=0;   
  root.nextleaf=&endleaf;
  endleaf.revleaf=&root;
  root.nodelist=&nodeend;
  nodeend.revnode=&root;
}



void develop(struct node *cube)
{
  char i;

  allocate(cube);   /*m*/

  operate(cube);    /*m[hWJ*/

  for(i=0;i<6;i++)
    heuristic(cube->next[i]);   /*WJem[h̃q[XeBbNlvZ*/

}



void allocate(struct node *cube)
{
  char i,j,k,l;
  struct node *nextcube;

  nextcube=(struct node *)malloc(sizeof(struct node)*6);  /*m*/
  if(!nextcube){
    printf("蓖ăG[\a\n");
    exit(1);
  }

  nodeend.revnode->nodelist=&nextcube[0];    /*m[hXgɂȂ*/

  cube->revleaf->nextleaf=&nextcube[0];     /*[tXgɂȂ*/
  nextcube[0].revleaf=cube->revleaf;



  for(i=0;i<5;i++){    /*m[hXgɂȂ,eƓԂRs[*/
    cube->next[i]=&nextcube[i];
    nextcube[i].reverse=cube;
    nextcube[i].nodelist=&nextcube[i+1];

    for(k=0;k<6;k++)
      for(j=0;j<D;j++)
        for(l=0;l<D;l++)
          nextcube[i].surface[k][j][l]=cube->surface[k][j][l];

    nextcube[i].cost=1+cube->cost;
    nextcube[i].nextleaf=&nextcube[i+1];
    nextcube[i+1].revleaf=&nextcube[i];

  }

  cube->next[5]=&nextcube[5];
  nextcube[5].reverse=cube;
  nextcube[5].nodelist=&nodeend;
  nodeend.revnode=&nextcube[5];

  for(k=0;k<6;k++)
    for(j=0;j<D;j++)
      for(l=0;l<D;l++)
        nextcube[5].surface[k][j][l]=cube->surface[k][j][l];

  nextcube[5].cost=cube->cost+1;
  nextcube[5].nextleaf=cube->nextleaf;
  cube->nextleaf->revleaf=&nextcube[5];

}




void operate(struct node *cube)      /*em[hŏԑJڂs*/
{
  struct node *nextcube;
  char i, k=0;


  if(cube->opecolor!=1){

    nextcube=cube->next[k++];

    for(i=0;i<D;i++){
      nextcube->surface[0][i][0]=cube->surface[3][i][0];
      nextcube->surface[2][i][0]=cube->surface[0][i][0];
      nextcube->surface[5][i][0]=cube->surface[2][i][0];
      nextcube->surface[3][i][0]=cube->surface[5][i][0];
    }

    Lrot(nextcube, cube, 1);

    nextcube->ope=-1;
    nextcube->opecolor=1;


    nextcube=cube->next[k++];

    for(i=0;i<D;i++){
      nextcube->surface[0][i][0]=cube->surface[5][i][0];
      nextcube->surface[2][i][0]=cube->surface[3][i][0];
      nextcube->surface[5][i][0]=cube->surface[0][i][0];
      nextcube->surface[3][i][0]=cube->surface[2][i][0];
    }

    rot(nextcube, cube, 1);

    nextcube->ope=0;
    nextcube->opecolor=1;


    nextcube=cube->next[k++];

    for(i=0;i<D;i++){
      nextcube->surface[0][i][0]=cube->surface[2][i][0];
      nextcube->surface[2][i][0]=cube->surface[5][i][0];
      nextcube->surface[5][i][0]=cube->surface[3][i][0];
      nextcube->surface[3][i][0]=cube->surface[0][i][0];
    }

    Rrot(nextcube, cube, 1);

    nextcube->ope=1;
    nextcube->opecolor=1;

  }


  if(cube->opecolor!=2){

    nextcube=cube->next[k++];

    for(i=0;i<D;i++){
      nextcube->surface[0][0][D-1-i]=cube->surface[1][D-1-i][1];
      nextcube->surface[4][i][0]=cube->surface[0][0][D-1-i];
      nextcube->surface[5][1][i]=cube->surface[4][i][0];
      nextcube->surface[1][D-1-i][1]=cube->surface[5][1][i];
    }

    Lrot(nextcube, cube, 2);

    nextcube->ope=-1;
    nextcube->opecolor=2;


    nextcube=cube->next[k++];

    for(i=0;i<D;i++){
      nextcube->surface[0][0][D-1-i]=cube->surface[5][1][i];
      nextcube->surface[4][i][0]=cube->surface[1][D-1-i][1];
      nextcube->surface[5][1][i]=cube->surface[0][0][D-1-i];
      nextcube->surface[1][D-1-i][1]=cube->surface[4][i][0];
    }

    rot(nextcube, cube, 2);

    nextcube->ope=0;
    nextcube->opecolor=2;


    nextcube=cube->next[k++];

    for(i=0;i<D;i++){
      nextcube->surface[0][0][D-1-i]=cube->surface[4][i][0];
      nextcube->surface[4][i][0]=cube->surface[5][1][i];
      nextcube->surface[5][1][i]=cube->surface[1][D-1-i][1];
      nextcube->surface[1][D-1-i][1]=cube->surface[0][0][D-1-i];
    }

    Rrot(nextcube, cube, 2);

    nextcube->ope=1;
    nextcube->opecolor=2;
  }


  if(cube->opecolor!=0){

    nextcube=cube->next[k++];

    for(i=0;i<D;i++){
      nextcube->surface[4][1][i]=cube->surface[3][0][D-1-i];
      nextcube->surface[2][1][i]=cube->surface[4][1][i];
      nextcube->surface[1][1][i]=cube->surface[2][1][i];
      nextcube->surface[3][0][D-1-i]=cube->surface[1][1][i];
    }

    Lrot(nextcube, cube, 0);


    nextcube->ope=-1;
    nextcube->opecolor=0;


    nextcube=cube->next[k++];

    for(i=0;i<D;i++){
      nextcube->surface[4][1][i]=cube->surface[1][1][i];
      nextcube->surface[2][1][i]=cube->surface[3][0][D-1-i];
      nextcube->surface[1][1][i]=cube->surface[4][1][i];
      nextcube->surface[3][0][D-1-i]=cube->surface[2][1][i];
    }

    rot(nextcube, cube, 0);

    nextcube->ope=0;
    nextcube->opecolor=0;


    nextcube=cube->next[k];

    for(i=0;i<D;i++){
      nextcube->surface[4][1][i]=cube->surface[2][1][i];
      nextcube->surface[2][1][i]=cube->surface[1][1][i];
      nextcube->surface[1][1][i]=cube->surface[3][0][D-1-i];
      nextcube->surface[3][0][D-1-i]=cube->surface[4][1][i];
    }

    Rrot(nextcube, cube, 0);

    nextcube->ope=1;
    nextcube->opecolor=0;
  }

}



void Lrot(struct node *next, struct node *original, char s)
{
  char i,j;

  for(i=0;i<D;i++)
    for(j=0;j<D;j++)
      next->surface[s][i][j]=original->surface[s][j][D-1-i];   /*]*/
}

void Rrot(struct node *next, struct node *original, char s)
{
  char i, j;

  for(i=0;i<D;i++)
    for(j=0;j<D;j++)
      next->surface[s][i][j]=original->surface[s][D-1-j][i];    /*E]*/
}


void rot(struct node *next, struct node *original, char s)
{
  char i,j;

  for(i=0;i<D;i++)
    for(j=0;j<D;j++)
      next->surface[s][i][j]=original->surface[s][D-i-1][D-1-j];    /*180x]*/
}



void heuristic(struct node *cube)
{
  char i,j,k,p=1,q;
  unsigned int color[6], dcube=0, buff=0, hash;
  struct node *node;

  if(cube->surface[0][0][0]!=goal.surface[0][0][0] || /*R[i[L[üʒu,Ă𐔂*/
cube->surface[2][1][0]!=goal.surface[2][1][0] || 
cube->surface[1][1][1]!=goal.surface[1][1][1])
    dcube++;

  if(cube->surface[0][0][1]!=goal.surface[0][0][1] || 
cube->surface[2][1][1]!=goal.surface[2][1][1] || 
cube->surface[4][1][0]!=goal.surface[4][1][0])
    dcube++;

  if(cube->surface[0][1][0]!=goal.surface[0][1][0] || 
cube->surface[1][1][0]!=goal.surface[1][1][0] || 
cube->surface[3][0][0]!=goal.surface[3][0][0])
    dcube++;

  if(cube->surface[0][1][1]!=goal.surface[0][1][1] || 
cube->surface[4][1][1]!=goal.surface[4][1][1] || 
cube->surface[3][0][1]!=goal.surface[3][0][1])
    dcube++;

  if(cube->surface[5][0][0]!=goal.surface[5][0][0] || 
cube->surface[3][1][0]!=goal.surface[3][1][0] || 
cube->surface[1][0][0]!=goal.surface[1][0][0])
    dcube++;

  if(cube->surface[5][0][1]!=goal.surface[5][0][1] || 
cube->surface[3][1][1]!=goal.surface[3][1][1] || 
cube->surface[4][0][1]!=goal.surface[4][0][1])
    dcube++;

  if(cube->surface[5][1][0]!=goal.surface[5][1][0] || 
cube->surface[2][0][0]!=goal.surface[2][0][0] || 
cube->surface[1][0][1]!=goal.surface[1][0][1])
    dcube++;

  if(cube->surface[5][1][1]!=goal.surface[5][1][1] || 
cube->surface[2][0][1]!=goal.surface[2][0][1] || 
cube->surface[4][0][0]!=goal.surface[4][0][0])
    dcube++;


  for(i=0;i<6;i++)
    color[i]=0;

  for(k=0;k<6;k++)
    for(i=0;i<D;i++)
      for(j=0;j<D;j++)
        if(goal.surface[k][i][j]!=cube->surface[k][i][j])
          color[k]++;     /*FĂ鐔𐔂*/

  for(i=0;i<6;i++)
    buff+=color[i];


  hash=1;
  for(i=0;i<6;i++)
    hash*=color[i];

  hash*=dcube;

  hash+=dcube+buff;

 
  if(!hash)
    cube->heuristic=0;

  else if(hash==12)
    cube->heuristic=1;

  else if(hash==884 || hash==402)
    cube->heuristic=2;

  else if(hash==1317 || hash==78 || hash==3426 || hash==1156 || hash==1750 || hash==788 || hash==160 || hash==5128 || hash==2291 || hash==6830 || hash==588)
    cube->heuristic=3;

  else if(hash==1966 || hash==378 || hash==3048 || hash==4561 || hash==2615 || hash==559 || hash==257 || hash==28 || hash==2039 || hash==452 || hash==307 || hash==9099 || hash==1558 || hash==106 || hash==2939 || hash==18 || hash==62 || hash==2040 || hash==3049 || hash==4057 || hash==1535 || hash==1030 || hash==778 || hash==2292 || hash==1534 || hash==234 || hash==506 || hash==210)
    cube->heuristic=4;

  else if(hash==739 || hash==1173 || hash==451 || hash==6074 || hash==3480 || hash==2327 || hash==197 || hash==124 || hash==337 || hash==343 || hash==136 || hash==668 || hash==1318 || hash==3912 || hash==1366 || hash==1031 || hash==1100 || hash==12124 || hash==8091 || hash==272 || hash==694 || hash==1029 || hash==143 || hash==595 || hash==208 || hash==498 || hash==4398 || hash==404 || hash==111 || hash==525 || hash==14 || hash==469)
    cube->heuristic=5;

  else if(hash==993 || hash==95 || hash==306 || hash==1724 || hash==23 || hash==403 || hash==885 || hash==596 || hash==2712 || hash==1174 || hash==789 || hash==1367 || hash==3609 || hash==176 || hash==597 || hash==338 || hash==177 || hash==258 || hash==37 || hash==669 || hash==288 || hash==180 || hash==2713 || hash==1751 || hash==16 || hash==5402 || hash==4058 || hash==45 || hash==693 || hash==740 || hash==1815 || hash==499 || hash==1967 || hash==918 || hash==379 || hash==1480 || hash==21 || hash==777 || hash==24 || hash==886 || hash==22)
    cube->heuristic=6;

  else if(hash==11 || hash==152 || hash==15 || hash==20 || hash==36 || hash==162 || hash==198 || hash==137 || hash==1368 || hash==17 || hash==50 || hash==13 || hash==75 || hash==1816 || hash==87 || hash==25 || hash==96 || hash==917)
    cube->heuristic=7;

  else if(hash==10 || hash==19 || hash==919)
    cube->heuristic=8;

  else
    cube->heuristic=9;


  cube->expectation=cube->heuristic+cube->cost;

  cube->hash=1.0;
  for(i=0;i<6;i++)
    cube->hash*=sin(color[i]+i*0.5);     /*OƓm[hWJȂ߂̃nbVlvZ*/

  cube->hash*=dcube;

  node=root.nodelist;    /*m[hXgǂ*/

  while(node!=cube && p){
    if(node->hash==cube->hash){    /*nbVlm[h*/
      q=0;

      for(k=0;k<5;k++)
for(i=0;i<D;i++)
  for(j=0;j<D;j++)
    if(cube->surface[k][i][j]!=node->surface[k][i][j])    /*Ԃڂr*/
      q++;

      if(!q){
        p=0;
        cube->revleaf->nextleaf=cube->nextleaf;    /*SȂ,̃m[h[tXg͂*/
        cube->nextleaf->revleaf=cube->revleaf;
      }
    }
  
    node=node->nodelist;
  }
}







void exception(void)    /*[gWĴƂP񂾂ĂяoBԑJڂԗ邽߂ƂRWJ*/
{
  struct node *leaf;
  char i,j,k,l;


  leaf=(struct node *)malloc(sizeof(struct node)*3);
  if(!leaf){
    printf("蓖ăG[\a\n");
    exit(1);
  }

  endleaf.revleaf->nextleaf=&leaf[0];
  leaf[0].revleaf=endleaf.revleaf;
  leaf[0].nextleaf=&leaf[1];
  leaf[1].revleaf=&leaf[0];
  leaf[1].nextleaf=&leaf[2];
  leaf[2].revleaf=&leaf[1];
  leaf[2].nextleaf=&endleaf;
  endleaf.revleaf=&leaf[2];

  for(i=0;i<3;i++)
    leaf[i].reverse=&root;

  nodeend.revnode->nodelist=&leaf[0];
  leaf[0].nodelist=&leaf[1];
  leaf[1].nodelist=&leaf[2];
  leaf[2].nodelist=&nodeend;
  nodeend.revnode=&leaf[2];

  for(i=0;i<3;i++){
    leaf[i].cost=1;
    leaf[i].ope=i-1;
    leaf[i].opecolor=0;
  }

  for(i=0;i<3;i++)
    for(k=0;k<6;k++)
      for(j=0;j<D;j++)
        for(l=0;l<D;l++)
          leaf[i].surface[k][j][l]=root.surface[k][j][l];


  for(i=0;i<D;i++){
    leaf[0].surface[4][1][i]=root.surface[3][0][D-1-i];
    leaf[0].surface[2][1][i]=root.surface[4][1][i];
    leaf[0].surface[1][1][i]=root.surface[2][1][i];
    leaf[0].surface[3][0][D-1-i]=root.surface[1][1][i];
  }

  Lrot(&leaf[0], &root, 0);


  for(i=0;i<D;i++){
    leaf[1].surface[4][1][i]=root.surface[1][1][i];
    leaf[1].surface[2][1][i]=root.surface[3][0][D-1-i];
    leaf[1].surface[1][1][i]=root.surface[4][1][i];
    leaf[1].surface[3][0][D-1-i]=root.surface[2][1][i];
  }

  rot(&leaf[1], &root, 0);


  for(i=0;i<D;i++){
    leaf[2].surface[4][1][i]=root.surface[2][1][i];
    leaf[2].surface[2][1][i]=root.surface[1][1][i];
    leaf[2].surface[1][1][i]=root.surface[3][0][D-1-i];
    leaf[2].surface[3][0][D-1-i]=root.surface[4][1][i];
  }

  Rrot(&leaf[2], &root, 0);

  for(i=0;i<3;i++)
    heuristic(&leaf[i]);

}




void search(void)     /*WJׂm[hT*/
{
  struct node *leaf;

  leaf=leaflist.nextleaf;
  min=50000;


  while(leaf->nextleaf){


    if(min>leaf->expectation){
      min=leaf->expectation;   /*[tXgǂheuristic+costŏ̂̂T*/
      minG=leaf;
    }

    leaf=leaf->nextleaf;
  }

}





void output(void)     /*\*/
{
  unsigned int i;
  struct node *p;

  p=minG;

  for(i=0;i<min;i++){    /*em[hǂĂđJڂ̗ǂ*/
    p->reverse->revnode=p;
    p=p->reverse;
  }

  printf("\n\n %d Ŋ\n\n\a",min);

  p=p->revnode;

  for(i=min;i;i--){
    switch(p->ope){     /*@\*/

      case 0:
        printf(" %c %c\n %c %c    ̖ʂ: 180]\n\n",p->reverse->surface[p->opecolor][0][0],p->reverse->surface[p->opecolor][0][1],p->reverse->surface[p->opecolor][1][0],p->reverse->surface[p->opecolor][1][1]);
        break;

      case 1:
        printf(" %c %c\n %c %c    ̖ʂ: 90Eɉ]\n\n",p->reverse->surface[p->opecolor][0][0],p->reverse->surface[p->opecolor][0][1],p->reverse->surface[p->opecolor][1][0],p->reverse->surface[p->opecolor][1][1]);
        break;

      case -1:
        printf(" %c %c\n %c %c    ̖ʂ:  90]\n\n",p->reverse->surface[p->opecolor][0][0],p->reverse->surface[p->opecolor][0][1],p->reverse->surface[p->opecolor][1][0],p->reverse->surface[p->opecolor][1][1]);
    };
 
    p=p->revnode;
  }

}


